// 判断是否为数字类型
function isNumber(value) {
    var patrn = /^(-)?\d+(\.\d+)?$/;
    if (patrn.exec(value) == null || value == "") {
        return false
    } else {
        return true
    }
}

/*** 
 * 模态框封装 
 */
var ahtml = '<div class="modal-dialog modal-sm">' +
                '<div class="modal-content">' +
                    '<div class="modal-header">' +
                        ' <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>' +
                        ' <h5 class="modal-title">[Title]</h5>' +
                    '</div>' +
                    '<div class="modal-body small" style="min-height:50px;">' +
                        '<div style="float:left;margin: 8px 24px;">'+
                            '[Icon]'+
                        '</div>'+
                        '<div style="float: left;margin-right: 10px;">'+
                            '<p style="margin-top: 16px;width: 280px;" id="msg_text">[Message]</p>'+
                        '</div>' +
                    '</div>' +
                    '<div class="modal-footer">' +
                        '<button type="button" class="btn-hl" data-dismiss="modal">[BtnHulue]</button>' +
                        '<button type="button" class="btn-cancel" data-dismiss="modal">[BtnCancel]</button>' +
                        '<button type="button" class="btn-confirm style-background-color" data-dismiss="modal">[BtnOk]</button>' +
                    '</div>' +
                '</div>' +
            '</div>';

function ModalObj(options) {
    var reg = new RegExp("\\[([^\\[\\]]*?)\\]", 'igm');
    var alr = $("#msg_show");
    var _tip = function (options, sec) {
        alr.html(ahtml); // 复原  
        alr.find('.ok').hide();
        alr.find('.cancel').hide();
        alr.width(options.width);
        _dialog(options, sec);

        return {
            on: function (callback) {}
        };
    };

    var _alert = function (options) {
        alr.html(ahtml); // 复原  
        alr.width(options.width);
        if (options.cancel) {
            alr.find('.btn-cancel').show();
        } else {
            alr.find('.btn-cancel').hide();
        }
        if(options.btnHL) {
            alr.find(".btn-hl").show();
        } else {
            alr.find(".btn-hl").hide();
        }
        if (options.confirm) {
            alr.find('.btn-confirm').show();
        } else {
            alr.find('.btn-confirm').hide();
        }
        _dialog(options);

        return {
            on: function (callback) {
                if (callback && callback instanceof Function) {
                    alr.find('.ok').click(function () {
                        callback(true)
                    });
                }
            }
        };
    };

    var _confirm = function (options, callback) {
        alr.html(ahtml); // 复原  
        alr.width(options.width);
        alr.find('.close').hide();//confirm不需要关闭按钮
        if (options.cancel) {
            alr.find('.btn-cancel').show();
        } else {
            alr.find('.btn-cancel').hide();
        }
        console.log(options,"------")
        if (options.btnHL) {
            alr.find(".btn-hl").show();
        } else {
            alr.find(".btn-hl").hide();
        }
        if (options.confirm) {
            alr.find('.btn-confirm').show();
        } else {
            alr.find('.btn-confirm').hide();
        }
        _dialog(options);
        return {
            on: function (callback) {
                if (callback && callback instanceof Function) {
                    alr.find('.btn-confirm').click(function () {
                        callback(true)
                    });
                    alr.find('.btn-cancel').click(function () {
                        callback(false)
                    });
                    alr.find('.btn-hl').click(function() {
                        callback("ignore");
                    })
                }
            }
        };
    };

    var _dialog = function (options) {
        var ops = {
            msg: langZh.TITLE_CONTENT,
            title: langZh.OPERATION_HINT,
            btnok: langZh.LOGIN_OKBUTTOM,
            btncl: langZh.LOGIN_CANCEL,
            btnhl: langZh.LOGIN_HULUE,
        };
        $.extend(ops, options);
        var html = alr.html().replace(reg, function (node, key) {
            return {
                Title: ops.title,
                Icon: ops.icon,
                Message: ops.msg,
                BtnOk: ops.btnok,
                BtnCancel: ops.btncl,
                BtnHulue: ops.btnhl,
            } [key];
        });

        alr.html(html);
        $(".btn-confirm").css("background-color", style_color);
        alr.modal({
            width: 250,
            backdrop: 'static'
        });
    }

    return {
        tip: _tip,
        alert: _alert,
        confirm: _confirm
    }
}

/** 
 * 显示消息 
 * @param msg 
 */
function showMsg(options, callback) {
    Modal = new ModalObj(options);
    Modal.alert({
        title: options.title,
        icon: options.icon,
        msg: options.msg,
        width: options.width,
        btnok: options.btnok,
        btncl: options.btncl,
        cancel: options.cancel,
        confirm: options.confirm,
        btnHL: options.btnHL
    }).on(function (e) {
        if (callback) {
            callback(e);
        }
    });
}
/** 
 * 模态对话框 
 * @param msg 
 * @returns 
 */
function showConfirm(options, callback) {
    Modal = new ModalObj(options);
    Modal.confirm({
        title: options.title,
        icon: options.icon,
        msg: options.msg,
        width: options.width,
        btnok: options.btnok,
        btncl: options.btncl,
        cancel: options.cancel,
        confirm: options.confirm,
        btnHL: options.btnHL
    }).on(function (e) {
        callback(e);
    });
}
/** 
 * 显示提示消息（自动关闭） 
 * @param options 模态框参数
 * @param callback 回调函数 
 */
function showTip(options, callback) {
    Modal = new ModalObj(options);
    if (!options.sec) {
        options.sec = 1000;
    }
    Modal.tip({
        title: options.title,
        icon: options.icon,
        msg: options.msg,
        width: options.width
    }, options.sec);
    setTimeout(callback, options.sec);
}

/*
 * 消息提示窗口
 * @param string: modType 弹出窗口消息类型 
 *          tip：显示提示消息（自动关闭）; msg：显示消息; confirm: 模态对话框; 
 * @param object对象: options 弹出窗口参数信息
 *          ip：错误弹窗ID; title：消息窗口参数; msg: 数字或字符串数字为错误码进行解析、字符直接显示; 
 *          width: 窗口宽度; btnok:确认按钮内容; btncl:取消按钮内容; sec: 自动关闭窗口,默认延迟1000毫秒
 * @param callback: 回调函数
 *
 */
function showPopMessage(modType, msgStr, callback) {
    var option = {
        title: langZh.MESSAGE_ERROR,
        width: 400,
        btnok: langZh.LOGIN_OKBUTTOM,
        btncl: langZh.LOGIN_CANCEL,
        btnhl: langZh.LOGIN_HULUE,
        sec: 1000
    }
    //msgStr信息为数字时进行错误码解析
    if(msgStr != undefined){
        if (isNumber(msgStr)) {
            if(langZh[msgStr] != undefined){
                option.msg = langZh[msgStr]+'('+ langZh.ERROR_CODE + msgStr +')';
            }else{
                option.msg = langZh.UNKNOW_ERROR_CODE + '('+ langZh.ERROR_CODE + msgStr +')';
            }
        } else {
            option.msg = msgStr;
        }
    }else{
        option.msg = langZh.ERROR_CODE_UNDEFINED;
    }
    // 获取当前页面是否显示modal框，如果存在显示modal要先关闭当前modal
    var modalShowid = '';
    var modalList = $(".modal");
    if(modalList.length > 0){
        modalList.each(function(){
            if($(this).hasClass('in')){
                modalShowid = $(this).attr('id');
                $("#"+modalShowid).modal('hide');
                $(".modal-backdrop").remove();
            }
        })
    }
    setTimeout(function () {
        showMsgModal(modType, option, callback);
    }, 500);
}

function showMsgModal(modType, option, callback) {
    switch (modType) {
        case 'tip':
            showTip(option, callback);
            break;
        case 'msgInfo':
            option.cancel = false;//隐藏取消按钮
            option.confirm = true;//显示确定按钮
            option.title = langZh.INFO
            option.icon = '<i class="icon-res-info-circle error-message-icon" style="color:#03a9f4;"></i>';
            showMsg(option, callback);
            break;
        case 'msgWarning':
            option.cancel = false;//显示取消按钮
            option.confirm = true;//显示确定按钮
            option.title = langZh.WARNING;
            option.icon = '<i class="icon-res-exclamation-triangle error-message-icon" style="color:#ffc107;"></i>';
            showMsg(option, callback);
            break;
        case 'msgError':
            option.cancel = false;//显示取消按钮
            option.confirm = true;//显示确定按钮
            option.title = langZh.ERROR;
            option.icon = '<i class="icon-res-times-circle error-message-icon" style="color:#f44336;"></i>';
            showMsg(option, callback);
            break;
        case 'confirm':
            option.cancel = true;//显示取消按钮
            option.confirm = true;//显示确定按钮
            option.title = langZh.CAREFUL;
            option.icon = '<i class="icon-res-exclamation-triangle error-message-icon" style="color:#ffc107;"></i>';
            showConfirm(option, callback);
            break;   
        case 'confirmInfo':
            option.cancel = true;//显示取消按钮
            option.confirm = true;//显示确定按钮
            option.title = langZh.INFO;
            option.icon = '<i class="icon-res-info-circle error-message-icon" style="color:#03a9f4;"></i>';
            showConfirm(option, callback);
            break;
        case 'updateInfo':
              option.cancel = false;//显示取消按钮
              option.confirm = true;//显示确定按钮
              option.title = langZh.FINDNEWVERSION;
              option.icon = '<i class="icon-res-info-circle error-message-icon" style="color:#03a9f4;"></i>';
              showConfirm(option, callback);
              break;
        case 'updated':
                option.cancel = false;//显示取消按钮
                option.confirm = true;//显示确定按钮
                option.title = langZh.DOWDLOADOK;
                option.icon = '<i class="icon-res-info-circle error-message-icon" style="color:#03a9f4;"></i>';
                showConfirm(option, callback);
                break;
        case 'update':
                option.cancel = true;//显示取消按钮
                option.confirm = true;//显示确定按钮
                option.btnHL = true;
                option.title = langZh.FINDNEWVERSION;
                option.icon = '<i class="icon-res-info-circle error-message-icon" style="color:#03a9f4;"></i>';
                showConfirm(option, callback);
                break;
        case 'updateError':
                option.cancel = true;//隐藏取消按钮
                option.confirm = true;//显示确定按钮
                option.title = langZh.DOWLOADERROR;
                option.icon = '<i class="icon-res-times-circle error-message-icon" style="color:red;"></i>';
                showConfirm(option, callback);
                break;
        case 'confirmError':
            option.cancel = false;//隐藏取消按钮
            option.confirm = true;//显示确定按钮
            option.title = langZh.ERROR;
            option.icon = '<i class="icon-res-times-circle error-message-icon" style="color:red;"></i>';
            showConfirm(option, callback);
            break;
        case 'msgInfoConfirmHide':
            option.cancel = false;//隐藏取消按钮
            option.confirm = false;//隐藏取消按钮
            option.title = langZh.INFO
            option.icon = '<i class="icon-res-info-circle error-message-icon" style="color:#03a9f4;"></i>';
            showConfirm(option, callback);
            break;
        default:
            break;
    }
}
function showPopMessageNew(id, msgStr) {
    if(msgStr != undefined){
        if (isNumber(msgStr)) {
            if(langZh[msgStr] != undefined){
                msg = langZh[msgStr]+'('+ langZh.ERROR_CODE + msgStr +')';
            }else{
                msg = langZh.UNKNOW_ERROR_CODE + '('+ langZh.ERROR_CODE + msgStr +')';
            }
        } else {
            msg = msgStr;
        }
    }else{
        msg = langZh.ERROR_CODE_UNDEFINED;
    }
    $('#' + id).html(msg);
}


var timeOutHide;
var msgString;
function showTipMessage(type,msgStr){  
    //msgStr信息为数字时进行错误码解析
    if(msgStr != undefined){
        if (isNumber(msgStr)) {
            if(langZh[msgStr] != undefined){
                msgString = langZh[msgStr]+'('+ langZh.ERROR_CODE + msgStr +')';
            }else{
                msgString = langZh.UNKNOW_ERROR_CODE + '('+ langZh.ERROR_CODE + msgStr +')';
            }
        } else {
            msgString = msgStr;
        }
    }else{
        msgString = langZh.ERROR_CODE_UNDEFINED;
    }
    clearTimeout(timeOutHide); 
    $("#tips_msg").show(); 
    if(type == 'success'){
        $("#tips_msg").addClass('suc in');
        var tipsHtml = '<i class="4 icon-res-check-circle" style="color:#51c41a;font-size:16px;position:relative;top:-2px;right:4px;"></i>'+ msgString +'</span>'
        $("#tips_msg").html(tipsHtml);
        timeOutHide = setTimeout(function () {
            $("#tips_msg").removeClass('in');
            clearTimeout(timeOutHide);
        },2000);
    } else if(type == 'error'){
        $("#tips_msg").addClass('err in'); 
        var tipsHtml = '<i class="4 icon-res-times-circle" style="color:#f5222d;font-size:16px;position:relative;top:-2px;right:4px;"></i>'+ msgString +'</span>'
        $("#tips_msg").html(tipsHtml);
    }else{
        $("#tips_msg").addClass('war in'); 
        var tipsHtml = '<i class="4 icon-res-exclamation-circle" style="color:#faad14;font-size:16px;position:relative;top:-2px;right:4px;"></i>'+ msgString +'</span>'
        $("#tips_msg").html(tipsHtml);
    }    
}
